
#include <time.h>
#include "math.h"
#include "../../kernel/include/lastwave.h"
#include <../../package_signal/include/signals.h>
#include "../../package_wtrans1d/include/wtrans1d.h"

                                                           

int log2_int(int x) {
//an int power of log2(x)
    int x_2,j;

    for(j=0,x_2=1;x_2<=x;j++,x_2=x_2<<1);

    return(--j);
}

float WLM_GET_S (WTRANS wTrans,float q,int scale,double threshold) {
    int j,nbCoeff,nulFlag=0;
    long double sum;


    for(j=0,nbCoeff=0,sum=0;j<(wTrans->D[scale][0])->size;j++) {
	if((wTrans->D[scale][0])->Y[j]>threshold) {
	  nbCoeff++;
	  sum+=pow((wTrans->D[scale][0])->Y[j],q);
	} else nulFlag++;
    }

     sum/=pow(2.,-(scale-1));
//the coefficient before the sum

    sum/=(long double) nbCoeff;
//since the null values have been excluded, we normalize the coefficients

    return (float) sum;
}

void WLM_GET_TAU (char **argv) {


    int j,norm;
    SIGNAL tau;
    WTRANS wTrans;
    double threshold; /*the threshold under which no value are taken into account*/
    float q;

    argv = ParseArgv(argv,tWTRANS_,NULL,&wTrans,tSIGNAL,&tau,tFLOAT,&q,tDOUBLE_,1e-12,&threshold,0);

    if (wTrans == NULL) wTrans = GetWtransCur();
//if no wavelet defined, we use the default one

    if(wTrans->type!=W_ORTH) Errorf("WLM needs orthogonal wavelet transform");
//Is it an owt ?
  

    SizeSignal(tau,wTrans->nOct,XYSIG);


    for(j=0;j<wTrans->nOct;j++) {
      tau->Y[j]=log(WLM_GET_S(wTrans,q,j+1,threshold));
      tau->X[j]=j*log(2);
    }

//we build tau
}

void WLM(char **argv)
{

  int j,k,l;
  int nb_coeff_lost=0,nOct,flag;

   WTRANS wTrans;
   int wSize;
   float time,exponent,threshold;

   float **res;
//the reseau


   argv = ParseArgv(argv,tWTRANS_,NULL,&wTrans,tFLOAT_,1e-12,&threshold,0);

  if (wTrans == NULL) wTrans = GetWtransCur();
//if no wavelet defined, we use the default one

  if(wTrans->type!=W_ORTH) Errorf("WLM needs orthogonal wavelet transform");
//Is it an owt ?
  
  time = MyTime();
  
  nOct=wTrans->nOct;

  for(j=0;j<nOct;j++)
      for(k=0;k<(wTrans->D[j+1][0])->size;k++) {
	  (wTrans->D[j+1][0])->Y[k]=fabs((wTrans->D[j+1][0])->Y[k]);
      }
  //we use the abs


  for(j=1;j<nOct;j++) {
      for (k=0;k<(wTrans->D[j+1][0])->size;k++) {

	  if ((wTrans->D[j][0])->Y[k*2]>(wTrans->D[j+1][0])->Y[k]) 
	       (wTrans->D[j+1][0])->Y[k]=(wTrans->D[j][0])->Y[k*2];
	  if ((wTrans->D[j][0])->Y[k*2+1]>(wTrans->D[j+1][0])->Y[k]) 
	       (wTrans->D[j+1][0])->Y[k]=(wTrans->D[j][0])->Y[k*2+1];

	  /*if ((wTrans->D[j][0])->Y[k*2]<threshold || (wTrans->D[j][0])->Y[k*2+1]<threshold) 
	    (wTrans->D[j+1][0])->Y[k]=0;*/

      }
  }
//we build the "reseau"


  res= (float**) malloc(nOct*sizeof(float*));
  for(j=0;j<nOct;j++) res[j]=(float*) malloc((wTrans->D[j+1][0]->size)*sizeof(float));
  //a reseau
  for(j=0;j<nOct;j++)
    for(k=0;k<wTrans->D[j+1][0]->size;k++) res[j][k]=wTrans->D[j+1][0]->Y[k];
  //that is a copy of the wt

  for(j=1;j<=nOct;j++)
    for (k=0;k<(wTrans->D[j][0])->size;k++) {
      if (k>0)
	if (res[j-1][k]<res[j-1][k-1]) wTrans->D[j][0]->Y[k]=res[j-1][k-1];
      if (k+1<(wTrans->D[j][0])->size)
	if (res[j-1][k]<res[j-1][k+1]) wTrans->D[j][0]->Y[k]=res[j-1][k+1];
    }
  for(j=0;j<nOct;j++) free(res[j]);
  free(res);
  //we take the sup on the neighbors


  for(j=0;j<wTrans->D[nOct][0]->size;j++) {
//for each coeff at the bigest scale

    for(k=1,flag=0;k<=nOct;k++)
//we look at all the scale
      for(l=0;l<(1<<(nOct-k));l++) {
//the coefficients depending of the coefficient j at the biggest scale
	if (wTrans->D[k][0]->Y[(j*(1<<(nOct-k)))+l]<threshold) flag=1;
      }

    if (flag) {
 //a vanishing coefficient has been found
     nb_coeff_lost++;
     for(k=1,flag=0;k<=nOct;k++)
       for(l=0;l<(1<<(nOct-k));l++) {
	 wTrans->D[k][0]->Y[(j*(1<<(nOct-k)))+l]=0;
       }
//we set all the corresponding coefficients to 0
    }

  }//end for j
//we set all the leaders above a null value to zero

  if (nb_coeff_lost>0) Printf("%d vanishing coefficients have been found, %d coefficients remaining at the biggest scale\n",nb_coeff_lost,wTrans->D[nOct][0]->size-nb_coeff_lost);

  SetResultf("%g",MyTime()-time); 

} 

void DELCOEF(char **argv) {
  WTRANS wTrans;
  int j,k,l;
  int pos,nOct,size;

  argv = ParseArgv(argv,tWTRANS_,NULL,&wTrans,tINT_,1,&pos,0);
   if (wTrans == NULL) wTrans = GetWtransCur();
   //if no wavelet defined, we use the default one

   if(wTrans->type!=W_ORTH) Errorf("Orthogonal wavelet transform needed");
   //Is it an owt ?

   nOct=wTrans->nOct;
   size=wTrans->D[nOct][0]->size;

   for(j=0;j<pos;j++)
     for(k=1;k<=nOct;k++)
       for(l=0;l<(1<<(nOct-k));l++) {
	 wTrans->D[k][0]->Y[(j*(1<<(nOct-k)))+l]=0;
	 wTrans->D[k][0]->Y[((size-j-1)*(1<<(nOct-k)))+l]=0;
	 //the same but at the end of the WT
       }
//we set the the pos first coefficients to zero at the beginning and the end
  
}

void NORMWT(char **argv) {
  //renormalize an owt

   WTRANS wTrans;
   int j,k,nOct;
   float exponent,time;

   argv = ParseArgv(argv,tWTRANS_,NULL,&wTrans,tFLOAT_,0.5,&exponent,0);
   if (wTrans == NULL) wTrans = GetWtransCur();
   //if no wavelet defined, we use the default one

   if(wTrans->type!=W_ORTH) Errorf("Orthogonal wavelet transform needed");
   //Is it an owt ?
  
  time = MyTime();
  
  nOct=wTrans->nOct;

  for(j=0;j<nOct;j++)
      for(k=0;k<(wTrans->D[j+1][0])->size;k++) {
	(wTrans->D[j+1][0])->Y[k]=(wTrans->D[j+1][0])->Y[k]/pow(2.,exponent*j);
      }
//we use another norm

  for(j=nOct-1,k=2;j>=1;j--)
    for(k=(wTrans->D[nOct][0]->size)<<(nOct-j);k<wTrans->D[j][0]->size;k++)
      wTrans->D[j][0]->Y[k]=0;
//we need a factor 2 between 2 scale; we delete the other coefficients

  SetResultf("%g",MyTime()-time); 

}

